c	***********************************************************
      subroutine intensity
c
c	ti is intensity transmitted.
c	tq,tu, are transmitted stokes parameters
c	ri  intensity reflected.
c	rq,ru,rv are reflected stokes parameters.
c
c history:
c 95/01/17 (mjw): add calls to WRIMSG
c

c
      character cmsgnm*70
      real*4 norm,tmp,rn
      include 'arrays.txt'
      include 'blob.txt'
      include 'stokes.txt'
      external WRIMSG
	
      aphot=photons
c     first, errors, before reassigning erro(l)
      do l=1,mc
	   rn=erro(l)
	   tmp=sqrt(1./rn/(rn-1))
         ti2(l)=tmp*sqrt(ti2(l)-(ti(l)**2/rn))
         tq2(l)=tmp*sqrt(tq2(l)-(tq(l)**2/rn))
         tu2(l)=tmp*sqrt(tu2(l)-(tu(l)**2/rn))
         tv2(l)=tmp*sqrt(tv2(l)-(tv(l)**2/rn))
	end do

c ...
c     intensity
c        i=de/(mu*dmu*dphi)
c        dmu=1/bina; dphi=2*pi/binb;
c        (pi*i)/(unot*f)=n*bina*binb/(pi*ntot*cost*sint)
c     if binning in theta, instead of mu.
c     not sure if i need an extra 2*pi for dphi.
c     flux
c        f=n/np/(2*pi*sint*dt)
c        dt=pi/binc
c        so f=n/np*binc/(2*pi**2*sint)
c ...
      norm=2.*pi*pi*aphot/binc
      fluxo=0.0
      fluxi=0.0
      sum=0
      do l=1,mc
	 unorm=sin(theta(l)*pi/180.)*norm
         sum=sum+erro(l)
         fluxo=fluxo+ti(l)
         if(erro(l).gt.0)erro(l)=1./sqrt(abs(erro(l)))
c     change numbers to intensities--note, same arrays
         ti(l)=ti(l)/unorm
         tq(l)=tq(l)/unorm
         tu(l)=tu(l)/unorm
         tv(l)=tv(l)/unorm
      end do
      aflux=aflux/(aflux+sum)
      fluxo=fluxo/aphot
      scatave=totscat/sum
      write(cmsgnm,'(1pe12.4,a)')totscat,' = TOTSCAT'
      call WRIMSG('INTENSITY)',cmsgnm)
      write(cmsgnm,'(1pe12.4,a)')fluxo,' = FLUXO'
      call WRIMSG('INTENSITY',cmsgnm)
      write(cmsgnm,'(1pe12.4,a)')sum,' = SUM'
      call WRIMSG('INTENSITY',cmsgnm)

      return
      end
